# slap-client

SlapClient - JavaScript client for slap-client
This API provides the metrics and the metadata of songs in order to analyze Lyrics & Popularity
This SDK is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.0
- Package version: 1.0.0
- Build package: org.openapitools.codegen.languages.JavascriptClientCodegen

## Installation

### For [Node.js](https://nodejs.org/)

#### npm

To publish the library as a [npm](https://www.npmjs.com/), please follow the procedure in ["Publishing npm packages"](https://docs.npmjs.com/getting-started/publishing-npm-packages).

Then install it via:

```shell
npm install slap-client --save
```

Finally, you need to build the module:

```shell
npm run build
```

##### Local development

To use the library locally without publishing to a remote npm registry, first install the dependencies by changing into the directory containing `package.json` (and this README). Let's call this `JAVASCRIPT_CLIENT_DIR`. Then run:

```shell
npm install
```

Next, [link](https://docs.npmjs.com/cli/link) it globally in npm with the following, also from `JAVASCRIPT_CLIENT_DIR`:

```shell
npm link
```

To use the link you just defined in your project, switch to the directory you want to use your slap-client from, and run:

```shell
npm link /path/to/<JAVASCRIPT_CLIENT_DIR>
```

Finally, you need to build the module:

```shell
npm run build
```

#### git

If the library is hosted at a git repository, e.g.https://github.com/GIT_USER_ID/GIT_REPO_ID
then install it via:

```shell
    npm install GIT_USER_ID/GIT_REPO_ID --save
```

### For browser

The library also works in the browser environment via npm and [browserify](http://browserify.org/). After following
the above steps with Node.js and installing browserify with `npm install -g browserify`,
perform the following (assuming *main.js* is your entry file):

```shell
browserify main.js > bundle.js
```

Then include *bundle.js* in the HTML pages.

### Webpack Configuration

Using Webpack you may encounter the following error: "Module not found: Error:
Cannot resolve module", most certainly you should disable AMD loader. Add/merge
the following section to your webpack config:

```javascript
module: {
  rules: [
    {
      parser: {
        amd: false
      }
    }
  ]
}
```

## Getting Started

Please follow the [installation](#installation) instruction and execute the following JS code:

```javascript
var SlapClient = require('slap-client');


var api = new SlapClient.DefaultApi()
var songId = "songId_example"; // {String} 
var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
api.listSongWordFrequencyPlots(songId, callback);

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost:8000/api*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*SlapClient.DefaultApi* | [**listSongWordFrequencyPlots**](docs/DefaultApi.md#listSongWordFrequencyPlots) | **GET** /songs/{song_id}/word-frequency/plot | 
*SlapClient.DefaultApi* | [**listSwaggerSpecs**](docs/DefaultApi.md#listSwaggerSpecs) | **GET** /swagger-specs | 
*SlapClient.DefaultApi* | [**listWordFrequencys**](docs/DefaultApi.md#listWordFrequencys) | **GET** /songs/{song_id}/word-frequency | 
*SlapClient.DefaultApi* | [**listWordRandomizations**](docs/DefaultApi.md#listWordRandomizations) | **GET** /songs/words/randomize | 
*SlapClient.DefaultApi* | [**listWords**](docs/DefaultApi.md#listWords) | **GET** /songs/{song_id}/words | 
*SlapClient.DefaultApi* | [**retrieveRepetitionMatrixPlot**](docs/DefaultApi.md#retrieveRepetitionMatrixPlot) | **GET** /plot/rep-matrix/{song_id} | 
*SlapClient.DefaultApi* | [**retrieveSong**](docs/DefaultApi.md#retrieveSong) | **GET** /songs/{id}/ | 
*SlapClient.DefaultApi* | [**slapFlaskPublicControllersSongsGetParameterizedWordPopularitySingle**](docs/DefaultApi.md#slapFlaskPublicControllersSongsGetParameterizedWordPopularitySingle) | **GET** /song/{song_id}/word_popularity | 
*SlapClient.DefaultApi* | [**slapFlaskPublicControllersSongsGetSong**](docs/DefaultApi.md#slapFlaskPublicControllersSongsGetSong) | **GET** /song | 
*SlapClient.DefaultApi* | [**slapFlaskPublicControllersSongsGetSongGenres**](docs/DefaultApi.md#slapFlaskPublicControllersSongsGetSongGenres) | **GET** /song/genres | 
*SlapClient.DefaultApi* | [**slapFlaskPublicControllersSongsGetSongMetrics**](docs/DefaultApi.md#slapFlaskPublicControllersSongsGetSongMetrics) | **GET** /song/{song_id}/metrics | 
*SlapClient.DefaultApi* | [**slapFlaskPublicControllersSongsGetSongs**](docs/DefaultApi.md#slapFlaskPublicControllersSongsGetSongs) | **GET** /songs | 
*SlapClient.DefaultApi* | [**slapListRepetitionPopularityPlots**](docs/DefaultApi.md#slapListRepetitionPopularityPlots) | **GET** /plot/rep-pop | 


## Documentation for Models

 - [SlapClient.Artist](docs/Artist.md)
 - [SlapClient.Genre](docs/Genre.md)
 - [SlapClient.HttpError](docs/HttpError.md)
 - [SlapClient.InlineResponse200](docs/InlineResponse200.md)
 - [SlapClient.InlineResponse2001](docs/InlineResponse2001.md)
 - [SlapClient.InlineResponse2002](docs/InlineResponse2002.md)
 - [SlapClient.InlineResponse2003](docs/InlineResponse2003.md)
 - [SlapClient.Song](docs/Song.md)
 - [SlapClient.SongMetrics](docs/SongMetrics.md)
 - [SlapClient.SongMetricsChart](docs/SongMetricsChart.md)
 - [SlapClient.SongMetricsRepetition](docs/SongMetricsRepetition.md)
 - [SlapClient.SongMetricsRepetitionBow](docs/SongMetricsRepetitionBow.md)


## Documentation for Authorization

All endpoints do not require authorization.
